# Recipe Guide: Write a zkApp

*Hey there*, enterprising Web3 chef.&#x20;

Welcome to the exciting new world of RAILGUN zkApps.

With RAILGUN, you can give users the gift of privacy for nearly any decentralized app that runs via smart contracts. Cookbook makes it easy — numerous automated tests and code-validation help to ensure that users' funds will be safe every "Step" of the way.

### How it works

The RAILGUN Cookbook gives you the tools to write a "Recipe" to convert your dApp into a zkApp — [private and fully anonymous](https://docs.railgun.org/wiki/learn/privacy-system) for users. Your Recipe can interact with any smart contract using your private balance in [RAILGUN](https://docs.railgun.org/wiki/learn/overview).&#x20;

A Recipe contains a series of smart contact calls that are combined into a multi-call, which is actuated using [Wallet SDK](https://docs.railgun.org/developer-guide/wallet/private-wallets), or any RAILGUN-compatible wallet.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.railgun.org/developer-guide/cookbook/write.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
